# Архитектура

![Архитектура](images/archv2.png)
*Детальный вид архитектуры*

У базовых записей 4 метастолбца:

* Indirection
* Schema Encoding
* Start time
* Last update time

У хвостовых записей также 4 метастолбца, но последний это Base RID (вместо last update time). Следовательно четвертый столбец будет зависеть от типа страницы.

RID - это просто номер записи в файле. Тогда зная RID записи, мы можем посчитать на какой странице находится запись и ее смещение от начала страницы. Учитывая что данные выровнены по столбцам, то мы сможем легко восстановить запись.

Чтобы упростить поиск страниц конкретного столбца, мы решили на каждый столбец и метастолбец создавать два файла - один для базовых страниц, другой для хвостовых. Следовательно, Базовые и хвостовые записи находятся в разных файлах, поэтому решили, что tail RID тоже будет отсчитываться от 0, и соответственно base RID и tail RID будут находится в разных пространствах ключей (в отличии от статьи, где они находятся в одном пространстве, и при этом tail RID отсчитывается от, например, INT_MAX).

Далее нам необходимо поддерживать условие выровненности данных по столбцу. Для типов с фиксированной длиной это сделать легко - располагаем данные последовательно и дальше считаем смещение.

![Представление типа без фиксированной длины](images/fixed_size.png)
*Представление типа без фиксированной длины*

А для типов без фиксированной длины будем заводить еще один столбец, в котором будем хранить расположение данных в исходном столбце в виде кортежа (номер страницы, смещение, длина объекта). Таким образом, мы получаем также доступ к данным за О(1), без необходимости поиска.

Столбец Schema Encoding представляет из себя битовую маску. Самая простое решение это столбец uint64. Поэтому максимальное число пользовательских столбцов = 64.

Столбцы со временем (Start time и Last update time) можно заменить на идентификаторы транзакций, так как мы все равно фиксируем их время завершения.
