#ifndef LSTORE_BASE_JSONUTILS_H
#define LSTORE_BASE_JSONUTILS_H

#include <memory>
#include <vector>

#include "Base/json.h"

namespace lstore {

using json = nlohmann::json;

template <typename T>
void vector_from_json(const json& j, std::vector<T>& v) {
  for (auto& el : j) {
    T t;
    from_json(el, t);
    v.push_back(t);
  }
}

template<typename T>
void vector_to_json(json& j, std::vector<T>& v) {
  for (auto& item : v) {
    json t;
    to_json(t, item);
    j.push_back(t);
  }
}

} // namespace lstore

#endif // LSTORE_BASE_JSONUTILS_H