#include "Catalog/ColumnDesc.h"

namespace lstore {

ColumnDesc::ColumnDesc(const std::string& name, TypeId type_id, bool have_index)
    : name_(name), type_id_(type_id), have_index_(have_index) {}

void from_json(const json& j, ColumnDesc& c) {
  j.at("name").get_to(c.name_);
  j.at("haveIndex").get_to(c.have_index_);
  j.at("typeId").get_to(c.type_id_);
}

void to_json(json& j, ColumnDesc& c) {
  j["name"] = c.name_;
  j["haveIndex"] = c.have_index_;
  j["typeId"] = c.type_id_;
}

} // namespace lstore
