#include "Core/Storage.h"

// TODO: remove
#include <iostream>
#include "DataTypes/DataTypes.h"

namespace lstore {

Storage::Storage()
    : merge_manager_(page_manager_) {}

ResultSet Storage::insert(oid table_id, const Row& row) {
  Catalog& catalog = context_.getCatalog();
  TablePtr table = catalog.getTable(table_id);
  if (table->getUserColumnCount() != row.size()) {
    std::string error_message{"Insert error: the row size does not match the number of columns"};
    return ResultSet{error_message};
  }
  if (!page_manager_.isLoadedTable(table_id)) {
    page_manager_.loadTable(table);
  }
  InsertRange& insert_range = page_manager_.getInsertRange(table_id);
  insert_range.insert(0, row, merge_manager_); // TODO : get xid from Transaction manager
  std::vector<Row> res;
  return ResultSet{res};
}

ResultSet Storage::update(oid table_id, Value key, usize column_number,
                  Value new_value) {
  Catalog& catalog = context_.getCatalog();
  TablePtr table = catalog.getTable(table_id);
  (void) column_number;
  (void) new_value;
  UInt64 key_val = key.get<UInt64>();
  std::cout << "insert in " << table_id << " key: " << key_val <<  std::endl;

  std::vector<Row> res;
  return ResultSet{res};
}

ResultSet Storage::del(oid table_id, Value key) {
  Catalog& catalog = context_.getCatalog();
  TablePtr table = catalog.getTable(table_id);
  UInt64 key_val = key.get<UInt64>();
  std::cout << "insert in " << table_id << " key: " << key_val <<  std::endl;

  std::vector<Row> res;
  return ResultSet{res};
}

} // namespace lstore
