#ifndef LSTORE_CORE_STORAGE_H
#define LSTORE_CORE_STORAGE_H

#include "Base/types.h"
#include "Core/DbContext.h"
#include "Core/ResultSet.h"
#include "Core/Value.h"
#include "Pages/MergeManager.h"
#include "Pages/PageManager.h"

namespace lstore {

class Storage {
 public:
  Storage();

  Storage(const Storage&) = delete;
  Storage& operator=(const Storage&) = delete;
  Storage(Storage&&) = delete;
  Storage& operator=(Storage&&) = delete;

  ResultSet insert(oid table_id, const Row& row);

  ResultSet update(oid table_id, Value key, usize column_number,
                    Value new_value);

  /**
   * Delete
   */
  ResultSet del(oid table_id, Value key);

  DbContext& getContext() { return context_; }

 private:
  DbContext context_;
  PageManager page_manager_;
  MergeManager merge_manager_;
};

} // namespace lstore

#endif // LSTORE_CORE_STORAGE_H
