#ifndef LSTORE_DATATYPES_DATATYPESTRING_H
#define LSTORE_DATATYPES_DATATYPESTRING_H

#include "DataTypes/IDataType.h"
#include "DataTypes/StringSerialization.h"
#include "DataTypes/TypeId.h"
#include "DataTypes/TypeName.h"

namespace lstore {

class DataTypeString final : public IDataType {
 public:
  static constexpr auto kName = TypeName<String>;
  static constexpr auto kTypeId = TypeToTypeId<String>;
  static StringSerialization kSerialization;

  DataTypeString() = default;

  std::string_view getName() const override { return kName; }

  TypeId getTypeId() const override { return kTypeId; }

  ISerialization& getSerialization() override { return kSerialization; }

};

} // namespace lstore

#endif // LSTORE_DATATYPES_DATATYPESTRING_H
