#ifndef LSTORE_DATATYPES_STRINGSERIALIZATION_H
#define LSTORE_DATATYPES_STRINGSERIALIZATION_H

#include <cassert>
#include <cstring>
#include <string>

#include "DataTypes/DataTypes.h"
#include "DataTypes/ISerialization.h"
#include "DataTypes/TypeId.h"

namespace lstore {

class StringSerialization final : public ISerialization {
 public:
  StringSerialization() = default;
  ~StringSerialization() = default;

  void serialize(uint8* dest, Value val) override {
    assert(TypeId::String == val.getType());
    String& str = val.get<String>();
    usize len = str.length();
    memcpy(dest, str.data(), len);
  }

  Value deserialize(uint8* src, usize len) override {
    char* src_ptr = reinterpret_cast<char*>(src);
    String str{src_ptr, len};
    return str;
  }

};

} // namespace lstore

#endif // LSTORE_DATATYPES_STRINGSERIALIZATION_H
