#ifndef LSTORE_DATATYPES_TYPENAME_H
#define LSTORE_DATATYPES_TYPENAME_H

#include <string>

#include "DataTypes/DataTypes.h"

namespace lstore {

/**
 * Obtain type string representation from real type if possible.
 * @example TypeName<UInt8> == "UInt8"
 */
template <class T> constexpr inline std::string_view TypeName;

#define TYPENAME_MAP(_A) \
  template <> constexpr inline std::string_view TypeName<_A> = #_A;

TYPENAME_MAP(UInt8)
TYPENAME_MAP(UInt16)
TYPENAME_MAP(UInt32)
TYPENAME_MAP(UInt64)

TYPENAME_MAP(Int8)
TYPENAME_MAP(Int16)
TYPENAME_MAP(Int32)
TYPENAME_MAP(Int64)

TYPENAME_MAP(Float32)
TYPENAME_MAP(Float64)

TYPENAME_MAP(String)

#undef TYPENAME_MAP

} // namespace lstore

#endif // LSTORE_DATATYPES_TYPEID_H
