#include "DataTypes/TypeRegistry.h"

#include "DataTypes/DataTypeNumber.h"
#include "DataTypes/DataTypeString.h"

namespace lstore {

std::unordered_map<TypeId, DataTypePtr> TypeRegistry::types_;

void TypeRegistry::init() {
  if (types_.empty()) {
    types_[TypeId::UInt8] = std::make_shared<DataTypeUInt8>();
    types_[TypeId::UInt16] = std::make_shared<DataTypeUInt16>();
    types_[TypeId::UInt32] = std::make_shared<DataTypeUInt32>();
    types_[TypeId::UInt64] = std::make_shared<DataTypeUInt64>();
    types_[TypeId::Int8] = std::make_shared<DataTypeInt8>();
    types_[TypeId::Int16] = std::make_shared<DataTypeInt16>();
    types_[TypeId::Int32] = std::make_shared<DataTypeInt32>();
    types_[TypeId::Int64] = std::make_shared<DataTypeInt64>();
    types_[TypeId::Float32] = std::make_shared<DataTypeFloat32>();
    types_[TypeId::Float64] = std::make_shared<DataTypeFloat64>();
    types_[TypeId::String] = std::make_shared<DataTypeString>();
  }
}

} // namespace lstore
