#ifndef LSTORE_DATATYPES_TYPEREGISTRY_H
#define LSTORE_DATATYPES_TYPEREGISTRY_H

#include <unordered_map>

#include "DataTypes/IDataType.h"
#include "DataTypes/TypeId.h"

namespace lstore {

class TypeRegistry {
 public:
  static void init();

  static DataTypePtr& getType(TypeId id) { return types_[id]; }

  static DataTypePtr& getMetaColumnType() { return types_[TypeId::UInt64]; }

 private:
  static std::unordered_map<TypeId, DataTypePtr> types_;
};

} // namespace lstore

#endif // LSTORE_DATATYPES_TYPEREGISTRY_H
