#ifndef LSTORE_BTREEINDEX_H
#define LSTORE_BTREEINDEX_H

#include "Base/btree/disk_btree.h"
#include "Indexes/Index.h"

namespace lstore {

class BTreeIndex : public Index {
 public:
  explicit BTreeIndex(oid table_id, usize attr_number, const std::string& file_name)
    : Index(table_id, attr_number),
      map(file_name, 1UL << 25UL) // TODO get filename by tableId
  {}

  virtual void insert(uint64 key, rid val) override {
    map[key] = val;
  }

  virtual rid search(uint64 key) override {
    return map[key];
  }

  virtual void erase(uint64 key) override {
    map.erase(key);
  }

  virtual ~BTreeIndex() {}

 private:
  frozenca::DiskBTreeMap<uint64, rid> map;
};

} // namespace lstore

#endif // LSTORE_BTREEINDEX_H
