#ifndef LSTORE_INDEXES_INDEX_H
#define LSTORE_INDEXES_INDEX_H

#include <memory>

#include "Base/types.h"
#include "Core/Value.h"

namespace lstore {

class Index {
 public:
  explicit Index(oid table_id, usize attr_number)
    : table_id_(table_id), attr_number_(attr_number)
  {}

  virtual void insert(uint64 key, rid val) = 0;

  virtual rid search(uint64 key) = 0;

  virtual void erase(uint64 key) = 0;

  virtual ~Index() {}

  oid getTableId() const noexcept { return table_id_; }

  usize getAttrNumber() const noexcept { return attr_number_; }

 protected:
  oid table_id_;
  usize attr_number_;
};

using IndexPtr = std::shared_ptr<Index>;

} // namespace lstore

#endif // LSTORE_INDEXES_INDEX_H
