#ifndef LSTORE_PAGES_INSERTRANGE_H
#define LSTORE_PAGES_INSERTRANGE_H

#include <vector>

#include "Base/Spinlock.h"
#include "Base/types.h"
#include "Catalog/Table.h"
#include "Core/Value.h"
#include "Pages/Page.h"
#include "Pages/PageRanges.h"

namespace lstore {

// forward decl
class MergeManager;

class InsertRange {
 public:
  InsertRange(TablePtr& table, rid first);

  void insert(xid id, const Row& row, MergeManager& merge_manager);

  bool isFull();

 private:
  rid first_;
  rid current_;
  Spinlock spin_;
  TablePtr& table_;
  std::vector<PageRange> ranges_;

  struct InsertArgs {
    rid row_id;
    PageRange& cur_range;
    xid id;
  };

  PageRange createPageRange(usize column_count);
  void insertMetaData(InsertArgs& args);
  void insertUserData(InsertArgs& args, const Row& row);
};

} // namespace lstore

#endif // LSTORE_PAGES_INSERTRANGE_H
