#include "Pages/Page.h"

namespace lstore {

Allocator Page::allocator{ kPageSize, 0, true };

Page::Page() {
  void* mem = allocator.allocate();
  data = reinterpret_cast<uint8*>(mem);
}

Page::~Page() {
  allocator.deallocate(data);
}

Page::Page(Page&& other) {
  data = other.data;
  other.data = nullptr;
}

Page& Page::operator=(Page&& other) {
  data = other.data;
  other.data = nullptr;
  return *this;
}

} // namespace lstore
