#ifndef LSTORE_PAGES_PAGE_H
#define LSTORE_PAGES_PAGE_H

#include "Base/types.h"
#include "Base/Allocator.h"
#include "Core/Value.h"

namespace lstore {

constexpr usize kPageSize = 8192;

/**
 * Represents memory block from file.
 */
struct Page {
  static Allocator allocator;
  uint8* data;

  Page();
  ~Page();

  Page(const Page&) = delete;
  Page& operator=(const Page&) = delete;
  Page(Page&&);
  Page& operator=(Page&&);
};

} // namespace lstore

#endif // LSTORE_PAGES_PAGE_H
