#ifndef LSTORE_PAGES_PAGEID_H
#define LSTORE_PAGES_PAGEID_H

#include "Base/types.h"

namespace lstore {

class PageId {
 public:
  PageId(uint32 column_number, uint32 page_number)
      : column_number_(column_number), page_number_(page_number)
  {}

  PageId(const PageId&) = default;
  PageId& operator=(const PageId&) = default;
  PageId(PageId&&) = default;
  PageId& operator=(PageId&&) = default;

  uint32 getColumnNumber() const { return column_number_; }

  uint32 getPageNumber() const { return page_number_; }

 private:
  uint32 column_number_;
  uint32 page_number_;
};

} // namespace lstore

#endif // LSTORE_PAGES_PAGEID_H
