#ifndef LSTORE_PAGES_TAILRANGE_H
#define LSTORE_PAGES_TAILRANGE_H

#include <vector>

#include "Base/types.h"
#include "Catalog/Table.h"
#include "Core/Value.h"
#include "Pages/MergeManager.h"
#include "Pages/Page.h"

namespace lstore {

class TailRange {
 public:
  TailRange();

  rid insert(TablePtr& table, Value key, uint column_number,
              Value new_value, MergeManager& merge_manager);

  PageRange& getPages() { return pages_; }

 private:
  rid first_;
  rid current_;
  Spinlock spin_;
  PageRange pages_;
};

} // namespace lstore

#endif // LSTORE_PAGES_TAILRANGE_H
