#ifndef LSTORE_QUERIES_QUERY_H
#define LSTORE_QUERIES_QUERY_H

#include "Base/types.h"
#include "Core/Storage.h"
#include "Core/ResultSet.h"

namespace lstore {

class Query {
 public:
  explicit Query(oid table_id, Storage& storage)
    : table_id_(table_id), storage_(storage)
  {}

  virtual ResultSet execute() = 0;

  virtual ~Query() {}

 protected:
  oid table_id_;
  Storage& storage_;
};

} // namespace lstore

#endif // LSTORE_QUERIES_QUERY_H
